unit uFormIncluirObjetos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Grids,uTipo, Buttons, Uponto;

type
  TFormIncluir = class(TForm)
    Label1: TLabel;
    EditNome: TEdit;
    PageControlObjetos: TPageControl;
    TabSheetPonto: TTabSheet;
    TabSheetReta: TTabSheet;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    EditX: TEdit;
    EditY: TEdit;
    EditZ: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    EditX1: TEdit;
    EditY1: TEdit;
    EditZ1: TEdit;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    EditX2: TEdit;
    EditY2: TEdit;
    EditZ2: TEdit;
    TabSheetPoligono: TTabSheet;
    SGPoligono: TStringGrid;
    TabSheetBezier: TTabSheet;
    TabSheetSpline: TTabSheet;
    SGBezier: TStringGrid;
    SGSpline: TStringGrid;
    TabSheetWireFrame: TTabSheet;
    GroupBox4: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    GroupBox5: TGroupBox;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label17: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Button3: TButton;
    npontos: TLabel;
    Label22: TLabel;
    TabSheetSuperficie: TTabSheet;
    SGSuperficie: TStringGrid;
    ComboBoxSuperficie: TComboBox;
    ComboBoxDe: TComboBox;
    BitBtn1: TBitBtn;
    Label21: TLabel;
    ComboBoxPara: TComboBox;
    Label23: TLabel;
    Label24: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
     function verificaCampos: boolean;
    { Private declarations }
  public
    nwireframe : integer;
    wireframe : wf;
    objeto: string;
    ok : boolean;
    { Public declarations }
  end;

var
  FormIncluir: TFormIncluir;

implementation

uses UMain, uSuperficie;

{$R *.dfm}

function TFormIncluir.verificaCampos: boolean;
begin
 if EditNome.Text = '' then
    verificaCampos:= false
 else
   verificaCampos:= true;

 if PageControlObjetos.ActivePage = TabSheetPonto then begin
   objeto:='Ponto';
   if (EditX.Text = '') or (EditY.Text='') or (EditZ.Text ='') then
     verificaCampos:=false;
 end
 else
 if PageControlObjetos.ActivePage = TabSheetReta then begin
    objeto:='Reta';
    if (EditX1.Text = '') or (EditY1.Text='') or (EditZ1.Text ='') or
       (EditX2.Text = '') or (EditY2.Text='') or (EditZ2.Text ='') then
        verificaCampos:=false;
 end
 else
 if PageControlObjetos.ActivePage = TabSheetPoligono then
    objeto:='Poligono'
 else
 if PageControlObjetos.ActivePage = TabSheetBezier then
   objeto:='Bezier'
 else
 if PageControlObjetos.ActivePage = TabSheetSpline then
   objeto:='Spline'
 else
 if PageControlObjetos.ActivePage = TabSheetWireFrame then
   objeto:='WireFrame'
 else
 if PageControlObjetos.ActivePage = TabSheetSuperficie then
   objeto:='Superficie'
end;

procedure TFormIncluir.Button1Click(Sender: TObject);
begin
 if verificaCampos then begin
  ok:=true;
  close
 end
 else
  showmessage('Verifique os campos!');
end;

procedure TFormIncluir.Button2Click(Sender: TObject);
begin
 ok:=false;
 close;
end;

procedure TFormIncluir.FormCreate(Sender: TObject);
begin
 SGSuperficie.Cells[0,1]:='P1';
 SGSuperficie.Cells[0,2]:='P2';
 SGSuperficie.Cells[0,3]:='P3';
 SGSuperficie.Cells[0,4]:='P4';
 SGSuperficie.Cells[0,5]:='P5';
 SGSuperficie.Cells[0,6]:='P6';
 SGSuperficie.Cells[0,7]:='P7';
 SGSuperficie.Cells[0,8]:='P8';
 SGSuperficie.Cells[0,9]:='P9';
 SGSuperficie.Cells[0,10]:='P10';
 SGSuperficie.Cells[0,11]:='P11';
 SGSuperficie.Cells[0,12]:='P12';
 SGSuperficie.Cells[0,13]:='P13';
 SGSuperficie.Cells[0,14]:='P14';
 SGSuperficie.Cells[0,15]:='P15';
 SGSuperficie.Cells[0,16]:='P16';
 SGSuperficie.Cells[1,0]:='X';
 SGSuperficie.Cells[2,0]:='Y';
 SGSuperficie.Cells[3,0]:='Z';

 SGSuperficie.Cells[1,1]:='0';
 SGSuperficie.Cells[1,2]:='90';
 SGSuperficie.Cells[1,3]:='-20';
 SGSuperficie.Cells[1,4]:='110';
 SGSuperficie.Cells[1,5]:='0';
 SGSuperficie.Cells[1,6]:='150';
 SGSuperficie.Cells[1,7]:='40';
 SGSuperficie.Cells[1,8]:='120';
 SGSuperficie.Cells[1,9]:='40';
 SGSuperficie.Cells[1,10]:='120';
 SGSuperficie.Cells[1,11]:='1';
 SGSuperficie.Cells[1,12]:='50';
 SGSuperficie.Cells[1,13]:='80';
 SGSuperficie.Cells[1,14]:='50';
 SGSuperficie.Cells[1,15]:='15';
 SGSuperficie.Cells[1,16]:='90';

 SGSuperficie.Cells[2,1]:='0';
 SGSuperficie.Cells[2,2]:='0';
 SGSuperficie.Cells[2,3]:='40';
 SGSuperficie.Cells[2,4]:='80';
 SGSuperficie.Cells[2,5]:='15';
 SGSuperficie.Cells[2,6]:='22';
 SGSuperficie.Cells[2,7]:='120';
 SGSuperficie.Cells[2,8]:='10';
 SGSuperficie.Cells[2,9]:='1';
 SGSuperficie.Cells[2,10]:='3';
 SGSuperficie.Cells[2,11]:='50';
 SGSuperficie.Cells[2,12]:='30';
 SGSuperficie.Cells[2,13]:='190';
 SGSuperficie.Cells[2,14]:='170';
 SGSuperficie.Cells[2,15]:='120';
 SGSuperficie.Cells[2,16]:='130';

 SGSuperficie.Cells[3,1]:='0';
 SGSuperficie.Cells[3,2]:='0';
 SGSuperficie.Cells[3,3]:='20';
 SGSuperficie.Cells[3,4]:='50';
 SGSuperficie.Cells[3,5]:='0';
 SGSuperficie.Cells[3,6]:='10';
 SGSuperficie.Cells[3,7]:='20';
 SGSuperficie.Cells[3,8]:='70';
 SGSuperficie.Cells[3,9]:='1';
 SGSuperficie.Cells[3,10]:='50';
 SGSuperficie.Cells[3,11]:='50';
 SGSuperficie.Cells[3,12]:='80';
 SGSuperficie.Cells[3,13]:='40';
 SGSuperficie.Cells[3,14]:='50';
 SGSuperficie.Cells[3,15]:='60';
 SGSuperficie.Cells[3,16]:='30';

 SGPoligono.Cells[0,1]:='P1';
 SGPoligono.Cells[0,2]:='P2';
 SGPoligono.Cells[0,3]:='P3';
 SGPoligono.Cells[0,4]:='P4';
 SGPoligono.Cells[0,5]:='P5';
 SGPoligono.Cells[0,6]:='P6';
 SGPoligono.Cells[0,7]:='P7';
 SGPoligono.Cells[0,8]:='P8';
 SGPoligono.Cells[0,9]:='P9';
 SGPoligono.Cells[0,10]:='P10';
 SGPoligono.Cells[1,0]:='X';
 SGPoligono.Cells[2,0]:='Y';
 SGPoligono.Cells[3,0]:='Z';
 SGPoligono.Cells[1,1]:='0';
 SGPoligono.Cells[2,1]:='0';
 SGPoligono.Cells[3,1]:='0';
 SGPoligono.Cells[1,2]:='50';
 SGPoligono.Cells[2,2]:='0';
 SGPoligono.Cells[3,2]:='0';
 SGPoligono.Cells[1,3]:='50';
 SGPoligono.Cells[2,3]:='50';
 SGPoligono.Cells[3,3]:='0';
 SGPoligono.Cells[1,4]:='0';
 SGPoligono.Cells[2,4]:='50';
 SGPoligono.Cells[3,4]:='0';

 SGBezier.Cells[0,1]:='P1';
 SGBezier.Cells[0,2]:='P2';
 SGBezier.Cells[0,3]:='P3';
 SGBezier.Cells[0,4]:='P4';
 SGBezier.Cells[1,0]:='X';
 SGBezier.Cells[2,0]:='Y';
 SGBezier.Cells[3,0]:='Z';
 SGBezier.Cells[1,1]:='0';
 SGBezier.Cells[2,1]:='0';
 SGBezier.Cells[3,1]:='0';
 SGBezier.Cells[1,2]:='50';
 SGBezier.Cells[2,2]:='50';
 SGBezier.Cells[3,2]:='0';
 SGBezier.Cells[1,3]:='100';
 SGBezier.Cells[2,3]:='50';
 SGBezier.Cells[3,3]:='0';
 SGBezier.Cells[1,4]:='150';
 SGBezier.Cells[2,4]:='0';
 SGBezier.Cells[3,4]:='0';

 SGSpline.Cells[0,1]:='P1';
 SGSpline.Cells[0,2]:='P2';
 SGSpline.Cells[0,3]:='P3';
 SGSpline.Cells[0,4]:='P4';
 SGSpline.Cells[0,5]:='P5';
 SGSpline.Cells[0,6]:='P6';
 SGSpline.Cells[0,7]:='P7';
 SGSpline.Cells[0,8]:='P8';
 SGSpline.Cells[0,9]:='P9';
 SGSpline.Cells[0,10]:='P10';
 SGSpline.Cells[1,0]:='X';
 SGSpline.Cells[2,0]:='Y';
 SGSpline.Cells[3,0]:='Z';
 SGSpline.Cells[1,1]:='0';
 SGSpline.Cells[2,1]:='0';
 SGSpline.Cells[3,1]:='0';
 SGSpline.Cells[1,2]:='50';
 SGSpline.Cells[2,2]:='50';
 SGSpline.Cells[3,2]:='0';
 SGSpline.Cells[1,3]:='100';
 SGSpline.Cells[2,3]:='50';
 SGSpline.Cells[3,3]:='0';
 SGSpline.Cells[1,4]:='150';
 SGSpline.Cells[2,4]:='0';
 SGSpline.Cells[3,4]:='0';           
end;

procedure TFormIncluir.Button3Click(Sender: TObject);
begin
 inc(nwireframe);
 npontos.Caption:=floattostr(nwireframe);
 wireframe[nwireframe,01]:=strtofloat(edit1.Text);
 wireframe[nwireframe,02]:=strtofloat(edit2.Text);
 wireframe[nwireframe,03]:=strtofloat(edit3.Text);
 wireframe[nwireframe,04]:=strtofloat(edit4.Text);
 wireframe[nwireframe,05]:=strtofloat(edit5.Text);
 wireframe[nwireframe,06]:=strtofloat(edit6.Text);
 wireframe[nwireframe,07]:=strtofloat(edit7.Text);
 wireframe[nwireframe,08]:=strtofloat(edit8.Text);
 wireframe[nwireframe,09]:=strtofloat(edit9.Text);
end;

procedure TFormIncluir.FormShow(Sender: TObject);
begin
 nwireframe:=0;
 npontos.Caption:=inttostr(nwireframe);
end;

procedure TFormIncluir.BitBtn1Click(Sender: TObject);
 var
  n:integer;
  i, posDisplay: integer;
  _ponto : TPonto;
  de, para : array[0..3] of integer;
begin
 if ComboBoxSuperficie.ItemIndex = -1 then exit;

 posDisplay := 0;
 repeat
    inc(posDisplay);
 until ComboBoxSuperficie.Items.Strings[ComboBoxSuperficie.ItemIndex]=FormMain.DisplayFile[posDisplay].nome;

 n := ComboBoxDe.ItemIndex;
 if n < 4 then begin
    de[0] := n*4;
    de[1] := de[0]+1;
    de[2] := de[0]+2;
    de[3] := de[0]+3;
 end else begin
    de[0] := n-4;
    de[1] := de[0]+4;
    de[2] := de[0]+8;
    de[3] := de[0]+12;
 end;

 n := ComboBoxPara.ItemIndex;
 if n < 4 then begin
    para[0] := n*4 + 1;
    para[1] := para[0]+1;
    para[2] := para[0]+2;
    para[3] := para[0]+3;
 end else begin
    para[0] := n-3;
    para[1] := para[0]+4;
    para[2] := para[0]+8;
    para[3] := para[0]+12;
 end;

 for i := 0 to 3 do begin
    _ponto := TSuperficie(FormMain.DisplayFile[posDisplay]).retornaPonto(de[i]);
    SGSuperficie.Cells[1,para[i]] := floattostr(_Ponto.x);
    SGSuperficie.Cells[2,para[i]] := floattostr(_Ponto.y);
    SGSuperficie.Cells[3,para[i]] := floattostr(_Ponto.z);
 end;

end;

end.
