unit uFormTransformarObjetos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TFormTransform = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    PageControlTransform: TPageControl;
    TabSheetTranslacao: TTabSheet;
    TabSheetRotacao: TTabSheet;
    TabSheetEscalonamento: TTabSheet;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditDx: TEdit;
    EditDy: TEdit;
    EditDz: TEdit;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EditSx: TEdit;
    EditSy: TEdit;
    EditSz: TEdit;
    CheckBoxOrigem: TCheckBox;
    RadioGroupTipoRotacao: TRadioGroup;
    RadioGroupEixoRotacao: TRadioGroup;
    Angulo: TGroupBox;
    Label7: TLabel;
    EditAngulo: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function verificaCampos: boolean;
    { Private declarations }
  public
    ok : boolean;
    tipo: string;
    { Public declarations }
  end;

var
  FormTransform: TFormTransform;

implementation

{$R *.dfm}

function TFormTransform.verificaCampos: boolean;
begin
 if PageControlTransform.ActivePage = TabSheetTranslacao then begin
   tipo:='Translacao';
   if (EditDx.Text = '') or (EditDy.Text='') or (EditDz.Text ='') then
     verificaCampos:=false;
 end
 else
 if PageControlTransform.ActivePage = TabSheetEscalonamento then begin
   tipo:='Escalona';
   if (EditSx.Text = '') or (EditSy.Text='') or (EditSz.Text ='') then
     verificaCampos:=false;
 end
 else
  if PageControlTransform.ActivePage = TabSheetRotacao then begin
   tipo:='Rotacao';
   if (EditAngulo.Text = '') then
     verificaCampos:=false;
 end;
end;

procedure TFormTransform.Button1Click(Sender: TObject);
begin
 if verificaCampos then begin
  ok:=true;
  close
 end
 else
  showmessage('Verifique os campos!');
end;

procedure TFormTransform.Button2Click(Sender: TObject);
begin
 ok:=false;
 close;
end;

end.
