unit uListaLigada;

interface

uses  Classes, Dialogs, SysUtils;

type

   PN = ^an;
   an = record
     valor : TList;
   end;

   Pm = ^am;
   am = record
     valor : real;
   end;

  TListaLigada = class

  private
    listaN: tlist;
    function retornaElemento(i: integer): TList; {listaN eh a lista na qual cada elemento eh uma lista}
  public
    procedure setaValor(i, j: integer; _valor: real);
    constructor crie_se(_nlinhas,_ncolunas:integer);
    destructor destrua_se;
  published

  end;

implementation

constructor TListaLigada.crie_se;
begin
 listaN:=TList.Create;
end;

destructor TListaLigada.destrua_se;
begin
 listaN.free;
end;

function TListaLigada.retornaElemento(i : integer) : TList;
var
 elemento: Pn;
begin
    New(Elemento);
    Elemento:= listaN.items[i];
    result:=elemento^.valor;
end;

procedure TListaLigada.setaValor(i, j : integer; _valor: real);
var
 n : Pn;
 m : Pm;

 temp : TList;
begin
    temp:=retornaElemento(i);

    New(n);
    n^.valor := temp;

    New(m);
    m^.valor := _valor;
    temp.items[j]:=m;

    listaN.items[i]:=temp;
end;

end.
